local query_device_property_stat = {}
local json = require("json")
local utils = require("utils")
local utils_device = require("utils_device")

local function get_property(pk, dn, property_list, property_detail_list)

    if #property_list == 0 then
        return true, "", "", "{}" 
    end

    ret = utils_device.get_property_value(pk, dn, property_list)
    if (nil == ret) then
        return false, "device not response", "iot." 
    end

    for n, item in ipairs(property_detail_list) do
        
        item["Value"] = ret[item["Name"]]

    end

    return true, "", "", property_detail_list
end

local function get_properties_list(profile)
   
    local properties_name_list = {}
    local properties_detail_list = {}
    for _, factor in ipairs(profile["properties"]) do

        local factor_id = factor["identifier"]
        -- get and set service is the implicit services
        if ("set" ~= factor_id and "get" ~= factor_id) then
            local item = {}
            item["Name"] = factor_id 
            item["Value"] = nil 
            item["Time"] = tostring(os.time())
            item["DataType"] = factor["dataType"]["type"]
            item["Identifier"] = factor_id
            item["Unit"] = nil

            table.insert(properties_name_list, factor_id)
            table.insert(properties_detail_list, item)
        end
    end

    return properties_name_list, properties_detail_list
end

function query_device_property_stat.get_device_property_status(pk, dn)

    --FIXME: should follow new message style
    utils.check_pk(pk)
    utils.check_dn(dn)

    local ok, profile = utils_device.get_device_profile(pk, dn)
    if profile == nil then
        return false, "faild to find TSL for pk: "..pk.." dn: "..dn, "iot.product.name.error"
    end

    return get_property(pk, dn, get_properties_list(profile))
end

return query_device_property_stat

