local json = require("json")
local utils = require("utils")
local driver_utils = require("driver_utils")

local request_method = ngx.var.request_method

utils.check_login()
utils.check_permission("DriverManage") 

if ("POST" == request_method) then 
    local utils_header = require("utils_header")
    local params = utils_header.check_public_boby_data()
    local driverName = params["DriverName"]
    if driverName == nil or type(driverName) ~= "string" or #driverName <= 0 then
        utils.error_exit(400, "driver name should not be null")
    end
    local msg = utils.get_driver_config(driverName)
    local msg_ret = {}
    local msg_ret_data = {}

    msg_ret["code"] = 200
    msg_ret["message"] = "success"
    if msg ~= nil then
        msg_ret["data"] = json.decode(msg)
        ngx.say(json.encode(msg_ret)) 
    else
        tmp_str = "{\"code\": 200, \"message\": \"success\", \"data\": {}}"
        ngx.say(tmp_str) 
    end
    ngx.exit(ngx.HTTP_OK)
end

utils.error_exit(400, "unsupported request method")
------ EOF ------
