/*
 * Copyright (c) 2019 Alibaba Group Holding Ltd. All rights reversed.
 */

var Log = require('../../utils/log');
var TAG = '[SupportedServices]';
var broker = require('../../broker/index');

class Service {
  constructor() {}

  resetScenes() {
    broker.publish('resetScenes');
    return JSON.stringify({
      code: 0,
      message: 'success',
      data: {}
    });
  }

  description() {
    return JSON.stringify({
      code: 0,
      message: 'success',
      data: {
        ability: {
          ifttt: { version: '2.0' }
        }
      },
      moduleName: 'ifttt'
    });
  }

  deployScenes(resources) {
    Log.i(TAG, 'Deploy scenes begin...');
    var event = {
      ackCode: 10201,
      resources: resources
    };
    broker.publish('updateScenes', event);
    return JSON.stringify({
      code: 0,
      message: "success",
      data: {}
    });
  }

  deleteScenes(resources) {
    Log.i(TAG, 'Delete scenes begin...');
    var event = {
      ackCode: 10204,
      resources: resources
    };
    broker.publish('updateScenes', event);
    return JSON.stringify({
      code: 0,
      message: "success",
      data: {}
    });
  }
}

module.exports = new Service();