'use strict';
const child_process = require('child_process');
const path = require('path');
const Log = require("./utils/log");
const TAG = "[Scheduler]";
const {PROJECT_PATH} = require('./const');
var longliveProcess = {};

function Scheduler() {
};

Scheduler.prototype.schedule = function (jobInfo) {
  var entry = path.join(PROJECT_PATH, 'runner/index.js');
  var jobInfoStr = JSON.stringify(jobInfo);

  process.env.NODE_PATH = PROJECT_PATH + "/node_modules:" + PROJECT_PATH + "/runner/developer:" + PROJECT_PATH + "/../../lib";
  process.env.LD_LIBRARY_PATH = PROJECT_PATH + "/../../lib";
  const defaults = {
    cwd: undefined,
    env: process.env
  };
  var runner = child_process.spawn("node", [entry, '--info', jobInfoStr], defaults);
  runner.stdout.on('data', function (data) {
    Log.i(TAG, 'Runner.stdout:' + data);
  });

  runner.stderr.on('data', function (data) {
    Log.w(TAG, 'Runner.stderr:', data);
  });

  runner.on('close', function (code, signal) {
    Log.i(TAG, 'Runner closed, code:' + code + " signal =" + signal + " resoueceId = " + jobInfo.resourceId + " name =" + jobInfo.resourceName);
  });
};

Scheduler.prototype.stopListenLLProcess = function (id) {
  delete(longliveProcess[id]);
};

Scheduler.prototype.getLLProcess = function (id) {
  return longliveProcess[id];
};

module.exports = new Scheduler();
