#!/bin/bash

function gettop
{
    local TOPFILE=build/VERSION
    if [ -n "$TOP" -a -f "$TOP/$TOPFILE" ] ; then
        # The following circumlocution ensures we remove symlinks from TOP.
        (cd $TOP; PWD= /bin/pwd)
    else
        if [ -f $TOPFILE ] ; then
            # The following circumlocution (repeated below as well) ensures
            # that we record the true directory name and not one that is
            # faked up with symlink names.
            PWD= /bin/pwd
        else
            local HERE=$PWD
            local T=
            while [ \( ! \( -f $TOPFILE \) \) -a \( $PWD != "/" \) ]; do
                \cd ..
                T=`PWD= /bin/pwd -P`
            done
            \cd $HERE
            if [ -f "$T/$TOPFILE" ]; then
                echo $T
            fi
        fi
    fi
}

# Create runtime directory
mkdir -p /linkedge/run/ifttt

GW_LIB_DIR=$(gettop)/build/lib
GW_BIN_DIR=$(gettop)/build/bin
GW_IFTTT_DIR=$(gettop)/build/bin/ifttt

# Add node to PATH
export PATH=${GW_BIN_DIR}/fc-runtime/build-env/node/bin:$PATH

# Add lib to NODE_PATH
export NODE_PATH=${GW_LIB_DIR}:$NODE_PATH

# Set maximum thread number of libuv: not exceeding 128
export UV_THREADPOOL_SIZE=96

# Start IFTTT
node ${GW_IFTTT_DIR}/index.js &
